// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S184_ReferencesAlias.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S184_ReferencesAlias extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int aliasState = 4;
  public static final int complexAliasState = 6;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3, 3
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\1\2\0\2\1"+
    "\1\0\1\5\12\6\1\7\1\10\5\0\1\11\1\12"+
    "\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\20"+
    "\1\22\1\23\1\24\1\25\1\26\1\27\1\20\1\30"+
    "\1\31\1\32\1\33\1\20\1\34\3\20\1\35\1\0"+
    "\1\36\1\0\1\37\1\0\1\40\1\41\1\42\1\43"+
    "\1\44\1\45\1\46\1\0\1\47\1\0\1\50\1\51"+
    "\1\52\1\53\1\54\1\55\1\0\1\56\1\57\1\60"+
    "\1\61\1\0\1\62\270\0\2\47\115\0\1\57\u0182\0"+
    "\1\1\20\0\2\1\u0115\0\1\50\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\4\0\2\1\2\2\3\3\15\0\1\4\73\0\1\5"+
    "\113\0\1\5\15\0\1\5\27\0\1\6\1\0\1\5"+
    "\11\0\1\5\2\0\1\7\5\0\1\10\3\0\1\11"+
    "\1\0\1\12\5\0\1\13\1\0\1\12\53\0\1\14";

  private static int [] zzUnpackAction() {
    int [] result = new int[278];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\63\0\146\0\231\0\314\0\377\0\314\0\u0132"+
    "\0\314\0\u0165\0\u0198\0\u01cb\0\u01fe\0\u0231\0\u0264\0\u0297"+
    "\0\u02ca\0\u02fd\0\u0330\0\u0363\0\u0396\0\u03c9\0\u03fc\0\u042f"+
    "\0\314\0\u0462\0\u0495\0\u04c8\0\u04fb\0\u052e\0\u0561\0\u0594"+
    "\0\u05c7\0\u05fa\0\u062d\0\u0660\0\u0693\0\u06c6\0\u06f9\0\u072c"+
    "\0\u075f\0\u0792\0\u07c5\0\u07f8\0\u082b\0\u085e\0\u0891\0\u08c4"+
    "\0\u08f7\0\u092a\0\u095d\0\u0990\0\u09c3\0\u09f6\0\u0a29\0\u0a5c"+
    "\0\u0a8f\0\u0ac2\0\u0af5\0\u0b28\0\u0b5b\0\u0b8e\0\u0bc1\0\u0bf4"+
    "\0\u0c27\0\u0c5a\0\u0c8d\0\u0cc0\0\u0cf3\0\u0d26\0\u0d59\0\u0d8c"+
    "\0\u0dbf\0\u0df2\0\u0e25\0\u0e58\0\u0e8b\0\u0ebe\0\u0ef1\0\u0f24"+
    "\0\u0f57\0\u0f8a\0\u0fbd\0\u0ff0\0\314\0\u1023\0\u1056\0\u1089"+
    "\0\u10bc\0\u10ef\0\u1122\0\u1155\0\u1188\0\u11bb\0\u11ee\0\u1221"+
    "\0\u1254\0\u1287\0\u12ba\0\u12ed\0\u1320\0\u1353\0\u1386\0\u13b9"+
    "\0\u13ec\0\u141f\0\u1452\0\u1485\0\u14b8\0\u14eb\0\u151e\0\u1551"+
    "\0\u1584\0\u15b7\0\u15ea\0\u161d\0\u1650\0\u1683\0\u16b6\0\u16e9"+
    "\0\u171c\0\u174f\0\u1782\0\u17b5\0\u17e8\0\u181b\0\u184e\0\u1881"+
    "\0\u18b4\0\u18e7\0\u191a\0\u194d\0\u1980\0\u19b3\0\u19e6\0\u1a19"+
    "\0\u1a4c\0\u1a7f\0\u1ab2\0\u1ae5\0\u1b18\0\u1b4b\0\u1b7e\0\u1bb1"+
    "\0\u1be4\0\u1c17\0\u1c4a\0\u1c7d\0\u1cb0\0\u1ce3\0\u1d16\0\u1d49"+
    "\0\u1d7c\0\u1daf\0\u1de2\0\u1e15\0\u1e48\0\u1e7b\0\u1eae\0\u1ee1"+
    "\0\u1f14\0\u1f14\0\u1f47\0\u1f7a\0\u1fad\0\u1fe0\0\u2013\0\u2046"+
    "\0\u2079\0\u20ac\0\u20df\0\u2112\0\u2145\0\u2178\0\u21ab\0\u21de"+
    "\0\u21ab\0\u2211\0\u2244\0\u2277\0\u22aa\0\u22dd\0\u2310\0\u2343"+
    "\0\u2376\0\u23a9\0\u23dc\0\u240f\0\u2442\0\u2475\0\u24a8\0\u24db"+
    "\0\u250e\0\u2541\0\u2574\0\u25a7\0\u25da\0\u260d\0\314\0\u2640"+
    "\0\u2673\0\u2673\0\u26a6\0\u26d9\0\u270c\0\u273f\0\u2772\0\u27a5"+
    "\0\u27d8\0\u280b\0\u283e\0\u283e\0\u2871\0\314\0\u28a4\0\u28d7"+
    "\0\u290a\0\u293d\0\u2970\0\314\0\u29a3\0\u29d6\0\u2a09\0\314"+
    "\0\u2a3c\0\314\0\u2a6f\0\u2aa2\0\u2ad5\0\u2b08\0\u2b3b\0\314"+
    "\0\u2b6e\0\u2ba1\0\u2ba1\0\u2bd4\0\u2c07\0\u2c3a\0\u2c6d\0\u2ca0"+
    "\0\u2cd3\0\u2d06\0\u2d39\0\u2d6c\0\u2d9f\0\u2dd2\0\u2e05\0\u2e38"+
    "\0\u2e6b\0\u2e9e\0\u2ed1\0\u2f04\0\u2f37\0\u2f6a\0\u2f9d\0\u2fd0"+
    "\0\u3003\0\u3036\0\u3069\0\u309c\0\u30cf\0\u3102\0\u3135\0\u3168"+
    "\0\u319b\0\u31ce\0\u3201\0\u3234\0\u3267\0\u329a\0\u32cd\0\u3300"+
    "\0\u3333\0\u3366\0\u3399\0\u33cc\0\u33ff\0\314";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[278];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\35\5\1\6\25\5\35\7\1\10\25\7\35\11\1\12"+
    "\62\11\1\13\25\11\106\0\1\14\25\0\1\14\16\0"+
    "\1\15\100\0\1\16\25\0\1\16\34\0\1\17\25\0"+
    "\1\17\33\0\1\20\25\0\1\20\35\0\1\21\25\0"+
    "\1\21\33\0\1\22\25\0\1\22\34\0\1\23\25\0"+
    "\1\23\37\0\1\24\25\0\1\24\31\0\1\25\25\0"+
    "\1\25\37\0\1\26\25\0\1\26\34\0\1\27\25\0"+
    "\1\27\16\0\1\30\100\0\1\31\25\0\1\31\16\0"+
    "\1\32\62\0\1\33\64\0\2\34\1\35\1\34\1\36"+
    "\5\34\1\37\11\34\2\0\1\34\2\0\1\40\1\0"+
    "\1\41\4\0\1\42\24\0\1\43\1\0\1\44\5\0"+
    "\1\45\16\0\1\43\1\0\1\44\4\0\1\45\25\0"+
    "\1\46\1\0\1\47\4\0\1\50\1\0\1\51\3\0"+
    "\1\52\11\0\1\46\1\0\1\47\3\0\1\50\1\0"+
    "\1\51\3\0\1\52\12\0\1\53\1\0\24\34\2\0"+
    "\1\34\32\0\1\53\1\0\12\34\1\54\11\34\2\0"+
    "\1\34\11\0\1\55\20\0\1\53\1\0\22\34\1\56"+
    "\1\34\2\0\1\34\21\0\1\57\10\0\1\53\1\0"+
    "\4\34\1\60\17\34\2\0\1\34\4\0\1\61\41\0"+
    "\1\55\25\0\1\55\44\0\1\57\25\0\1\57\16\0"+
    "\1\61\26\0\1\61\41\0\1\62\25\0\1\62\44\0"+
    "\1\63\25\0\1\63\16\0\1\64\26\0\1\64\44\0"+
    "\1\65\25\0\1\65\41\0\1\66\25\0\1\66\16\0"+
    "\1\67\26\0\1\67\51\0\1\70\25\0\1\70\33\0"+
    "\1\71\25\0\1\71\2\0\2\53\2\0\3\53\1\72"+
    "\25\53\2\0\24\53\7\0\1\53\1\0\24\34\2\0"+
    "\1\73\62\0\1\74\32\0\1\53\1\0\24\34\2\0"+
    "\1\75\62\0\1\76\32\0\1\53\1\0\6\34\1\77"+
    "\15\34\2\0\1\34\6\0\1\100\33\0\1\100\26\0"+
    "\1\100\53\0\1\101\62\0\1\102\42\0\1\62\26\0"+
    "\1\62\27\0\1\103\26\0\1\103\43\0\1\104\25\0"+
    "\1\104\30\0\1\105\26\0\1\105\40\0\1\106\25\0"+
    "\1\106\37\0\1\107\25\0\1\107\13\0\1\110\63\0"+
    "\1\53\1\0\1\111\23\34\2\0\1\34\1\112\33\0"+
    "\1\112\26\0\1\112\31\0\1\53\1\0\12\34\1\113"+
    "\11\34\2\0\1\34\11\0\1\114\34\0\1\114\25\0"+
    "\1\114\20\0\1\53\1\0\24\34\2\0\1\115\62\0"+
    "\1\116\34\0\1\117\26\0\1\117\45\0\1\45\25\0"+
    "\1\45\50\0\1\120\46\0\1\121\25\0\1\121\50\0"+
    "\1\122\35\0\1\123\26\0\1\123\55\0\1\124\25\0"+
    "\1\124\6\0\1\110\27\0\1\125\33\0\1\53\1\0"+
    "\12\34\1\126\11\34\2\0\1\34\11\0\1\127\34\0"+
    "\1\127\25\0\1\127\20\0\1\53\1\0\4\34\1\130"+
    "\17\34\2\0\1\34\4\0\1\131\33\0\1\131\26\0"+
    "\1\131\25\0\1\53\1\0\1\132\23\34\2\0\1\34"+
    "\1\133\33\0\1\133\26\0\1\133\45\0\1\134\25\0"+
    "\1\134\25\0\1\135\26\0\1\135\56\0\1\136\34\0"+
    "\1\137\26\0\1\137\37\0\1\140\26\0\1\140\25\0"+
    "\1\141\62\0\1\53\1\0\10\34\1\142\13\34\2\0"+
    "\1\34\7\0\1\143\34\0\1\143\25\0\1\143\22\0"+
    "\1\53\1\0\6\34\1\144\15\34\2\0\1\34\6\0"+
    "\1\145\33\0\1\145\26\0\1\145\23\0\1\53\1\0"+
    "\12\34\1\146\11\34\2\0\1\34\11\0\1\147\34\0"+
    "\1\147\25\0\1\147\32\0\1\150\25\0\1\150\24\0"+
    "\1\151\26\0\1\151\47\0\1\51\25\0\1\51\32\0"+
    "\1\152\25\0\1\152\41\0\1\153\25\0\1\153\4\0"+
    "\2\141\2\0\3\141\1\154\25\141\2\0\24\141\7\0"+
    "\1\53\1\0\1\155\23\34\2\0\1\34\1\156\33\0"+
    "\1\156\26\0\1\156\31\0\1\53\1\0\24\34\2\0"+
    "\1\157\62\0\1\160\32\0\1\53\1\0\10\34\1\161"+
    "\13\34\2\0\1\34\7\0\1\162\34\0\1\162\25\0"+
    "\1\162\24\0\1\163\26\0\1\163\54\0\1\164\25\0"+
    "\1\164\23\0\1\165\25\0\1\165\22\0\1\166\61\0"+
    "\1\167\63\0\1\53\1\0\20\34\1\170\3\34\2\0"+
    "\1\34\17\0\1\171\34\0\1\171\25\0\1\171\12\0"+
    "\1\53\1\0\1\172\23\34\2\0\1\34\1\173\33\0"+
    "\1\173\26\0\1\173\31\0\1\53\1\0\1\174\23\34"+
    "\2\0\1\34\1\175\33\0\1\175\26\0\1\175\53\0"+
    "\1\176\25\0\1\176\20\0\1\153\26\0\1\153\27\0"+
    "\1\177\26\0\1\177\22\0\2\166\2\0\3\166\1\200"+
    "\25\166\2\0\24\166\6\0\1\167\27\0\1\201\33\0"+
    "\1\202\1\0\24\34\2\0\1\34\32\0\1\203\62\0"+
    "\1\53\1\0\12\34\1\204\11\34\2\0\1\34\11\0"+
    "\1\205\34\0\1\205\25\0\1\205\20\0\1\53\1\0"+
    "\20\34\1\206\3\34\2\0\1\34\17\0\1\207\34\0"+
    "\1\207\25\0\1\207\12\0\1\210\104\0\1\153\25\0"+
    "\1\153\11\0\1\211\54\0\35\212\1\0\25\212\2\202"+
    "\2\0\3\202\1\213\25\202\2\0\24\202\2\203\2\0"+
    "\3\203\1\214\25\203\2\0\24\203\7\0\1\53\1\0"+
    "\10\34\1\215\13\34\2\0\1\34\7\0\1\216\34\0"+
    "\1\216\25\0\1\216\22\0\1\217\1\0\24\34\2\0"+
    "\1\34\32\0\1\220\53\0\2\210\2\0\3\210\1\221"+
    "\25\210\2\0\24\210\6\0\1\211\27\0\1\222\24\0"+
    "\35\212\1\223\25\212\6\0\1\224\62\0\1\225\63\0"+
    "\1\53\1\0\1\226\23\34\2\0\1\34\1\227\33\0"+
    "\1\227\26\0\1\227\22\0\2\230\2\0\3\230\1\231"+
    "\3\230\1\232\21\230\2\0\3\230\1\232\20\230\2\233"+
    "\2\0\3\233\1\234\3\233\1\235\21\233\2\0\3\233"+
    "\1\235\20\233\6\0\1\236\54\0\35\237\1\0\25\237"+
    "\5\0\1\240\63\0\1\224\27\0\1\241\32\0\1\225"+
    "\27\0\1\242\33\0\1\53\1\0\20\34\1\243\3\34"+
    "\2\0\1\34\17\0\1\244\34\0\1\244\25\0\1\244"+
    "\3\0\2\230\2\0\3\230\1\231\25\230\2\0\24\230"+
    "\6\0\1\245\54\0\2\230\2\0\3\230\1\231\3\230"+
    "\1\246\21\230\2\0\3\230\1\246\20\230\2\233\2\0"+
    "\3\233\1\234\25\233\2\0\24\233\6\0\1\247\54\0"+
    "\2\233\2\0\3\233\1\234\3\233\1\250\21\233\2\0"+
    "\3\233\1\250\20\233\6\0\1\236\27\0\1\251\24\0"+
    "\35\237\1\252\25\237\23\0\1\253\25\0\1\253\11\0"+
    "\35\254\1\0\25\254\7\0\1\255\1\0\24\34\2\0"+
    "\1\34\32\0\1\256\61\0\1\245\27\0\1\257\24\0"+
    "\2\230\2\0\3\230\1\231\15\230\1\260\7\230\2\0"+
    "\14\230\1\260\7\230\6\0\1\247\27\0\1\261\24\0"+
    "\2\233\2\0\3\233\1\234\15\233\1\262\7\233\2\0"+
    "\14\233\1\262\7\233\35\263\1\0\25\263\5\0\1\264"+
    "\77\0\1\265\25\0\1\265\12\0\35\254\1\266\25\254"+
    "\2\255\2\0\3\255\1\267\25\255\2\0\24\255\2\256"+
    "\2\0\3\256\1\270\25\256\2\0\24\256\35\271\1\0"+
    "\25\271\2\230\2\0\3\230\1\231\13\230\1\272\11\230"+
    "\2\0\12\230\1\272\11\230\2\233\2\0\3\233\1\234"+
    "\13\233\1\273\11\233\2\0\12\233\1\273\11\233\35\263"+
    "\1\274\25\263\23\0\1\275\25\0\1\275\36\0\1\276"+
    "\25\0\1\276\14\0\1\277\63\0\1\300\62\0\1\301"+
    "\54\0\35\271\1\302\25\271\2\230\2\0\3\230\1\303"+
    "\25\230\2\0\24\230\2\233\2\0\3\233\1\304\25\233"+
    "\2\0\24\233\5\0\1\305\77\0\1\306\25\0\1\306"+
    "\50\0\1\307\47\0\1\310\25\0\1\310\17\0\1\300"+
    "\27\0\1\311\32\0\1\301\27\0\1\312\31\0\1\313"+
    "\63\0\1\314\62\0\1\315\77\0\1\316\25\0\1\316"+
    "\36\0\1\317\25\0\1\317\31\0\1\320\25\0\1\320"+
    "\12\0\35\321\1\0\25\321\23\0\1\322\25\0\1\322"+
    "\17\0\1\314\27\0\1\323\32\0\1\315\27\0\1\324"+
    "\46\0\1\325\25\0\1\325\50\0\1\326\51\0\1\327"+
    "\25\0\1\327\7\0\35\321\1\330\25\321\22\0\1\331"+
    "\25\0\1\331\12\0\35\332\1\0\25\332\25\0\1\333"+
    "\25\0\1\333\45\0\1\334\31\0\1\335\102\0\1\336"+
    "\25\0\1\336\7\0\35\332\1\337\25\332\36\0\1\340"+
    "\47\0\1\341\25\0\1\341\47\0\1\342\31\0\1\343"+
    "\77\0\1\344\25\0\1\344\35\0\1\345\25\0\1\345"+
    "\36\0\1\346\25\0\1\346\31\0\1\347\25\0\1\347"+
    "\50\0\1\350\51\0\1\351\25\0\1\351\45\0\1\352"+
    "\25\0\2\353\1\0\1\354\30\0\1\355\1\0\1\353"+
    "\50\0\1\356\25\0\1\356\32\0\1\357\25\0\1\357"+
    "\23\0\1\360\26\0\1\360\43\0\1\361\25\0\1\361"+
    "\43\0\1\362\25\0\1\362\30\0\1\363\25\0\1\363"+
    "\36\0\1\364\25\0\1\364\14\0\1\365\63\0\1\353"+
    "\66\0\1\366\14\0\1\367\11\0\1\366\13\0\1\367"+
    "\31\0\1\370\25\0\1\370\40\0\1\371\25\0\1\371"+
    "\15\0\1\372\26\0\1\372\47\0\1\373\25\0\1\373"+
    "\44\0\1\374\57\0\1\375\25\0\1\375\14\0\1\376"+
    "\26\0\1\376\26\0\1\377\64\0\1\u0100\26\0\1\u0100"+
    "\22\0\2\377\2\0\3\377\1\u0101\25\377\2\0\24\377"+
    "\32\0\1\u0102\25\0\1\u0102\10\0\1\u0103\71\0\1\u0104"+
    "\26\0\1\u0104\24\0\1\u0103\27\0\1\u0105\33\0\1\u0106"+
    "\53\0\35\u0107\1\0\25\u0107\2\u0106\2\0\3\u0106\1\u0108"+
    "\25\u0106\2\0\24\u0106\35\u0107\1\u0109\25\u0107\6\0\1\u010a"+
    "\61\0\1\u010b\63\0\1\u010a\27\0\1\u010c\47\0\1\u010d"+
    "\25\0\1\u010d\11\0\35\u010e\1\0\25\u010e\22\0\1\u010f"+
    "\25\0\1\u010f\12\0\35\u010e\1\u0110\25\u010e\25\0\1\u0111"+
    "\25\0\1\u0111\14\0\1\u0112\113\0\1\353\47\0\1\u0113"+
    "\25\0\1\u0113\33\0\1\u0114\25\0\1\u0114\37\0\1\u0115"+
    "\25\0\1\u0115\45\0\1\u0116\24\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[13362];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\4\0\1\11\1\1\1\11\1\1\1\11\2\1\15\0"+
    "\1\11\73\0\1\11\113\0\1\1\15\0\1\1\27\0"+
    "\1\11\1\0\1\1\11\0\1\1\2\0\1\11\5\0"+
    "\1\11\3\0\1\11\1\0\1\11\5\0\1\11\1\0"+
    "\1\1\53\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[278];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S184_ReferencesAlias() { }
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S184_ReferencesAlias(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 13: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 14: break;
          case 3:
            { checkEnd();
            }
          // fall through
          case 15: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 16: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 17: break;
          case 6:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		offset += yylength();
		position += retrievedEntity.getText().length();
            }
          // fall through
          case 18: break;
          case 7:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		
		annotationEntity.addRelatedEntity(retrievedEntity);

		position += retrievedEntity.getText().length();
		offset += yylength();
            }
          // fall through
          case 19: break;
          case 8:
            { start(new Reference(Entity.CL_REF), aliasState, false, false);
            }
          // fall through
          case 20: break;
          case 9:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		
		annotationEntity.addRelatedEntity(retrievedEntity);
		
		if(retrievedEntity.getValue().equals("COD_CIV") || retrievedEntity.getValue().equals("COD_PROC_CIV")) getLinkolnDocument().hasCodiceCivile = true;
		if(retrievedEntity.getValue().equals("COD_PEN") || retrievedEntity.getValue().equals("COD_PROC_PEN")) getLinkolnDocument().hasCodicePenale = true;

		position += retrievedEntity.getText().length();
		offset += yylength();
            }
          // fall through
          case 21: break;
          case 10:
            { start(new Reference(Entity.LEG_REF), aliasState, false, false);
            }
          // fall through
          case 22: break;
          case 11:
            { start(new Reference(Entity.EU_LEG_REF), aliasState, false, false);
            }
          // fall through
          case 23: break;
          case 12:
            { start(new Reference(Entity.LEG_REF), complexAliasState, false, false);
            }
          // fall through
          case 24: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S184_ReferencesAlias [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S184_ReferencesAlias scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S184_ReferencesAlias(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
